# require 'helper'

describe Echo::Search do

  describe "Mandatory parameters" do 
    before :each do
      @search = Echo::Search.new
    end    
    it "should fails if not query is provided" do
      lambda{ @search.build_query }.should raise_error { ArgumentError }
    end    
    it "should fails if not apikey is provided" do
      lambda{
        @search.build_query  :q => "scope:something"
      }.should raise_error {ArgumentError}
    end

    after do
      Echo.reset
    end    
  end

  describe "Queries" do
    before :each do
      Echo.configure do
        Echo.configure do |config|
          config.user = "test.aboutecho"
        end
      end
      @search = Echo::Search.new
    end

    describe "Raw Queries" do 
      it "should create a basic query" do      
        @search.build_query({
            :q => "scope: http://example.com/*"
          }).should == "/search?appkey=test.aboutecho&q=scope%3A+http%3A%2F%2Fexample.com%2F%2A"
      end
    end

    describe "API" do
      it "should find only tagged elements"
      it "should find not tagged elements"
    end
  end  
end
